// Copyright (C) 1996 DIMACS Center, Rutgers, The State University of New Jersey
// Author(s): Jonathan Berry
// This software is copyrighted by the DIMACS Center at Rutgers, The State
// University of New Jersey.  IT IS PROVIDED AS IS, AND THE AUTHORS, DIMACS, AND
// RUTGERS, THE STATE UNIVERSITY OF NEW JERSEY  DISCLAIM
// ALL LIABILITY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
// DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
// DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
// THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
// IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
// NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
// MODIFICATIONS.
// The authors hereby grant permission to use, copy, modify, distribute,
// and license this software and its documentation for any purpose, provided
// that existing copyright notices are retained in all copies and that this
// notice is included verbatim in any distributions. No written agreement,
// license, or royalty fee is required for any of the authorized uses.
// Modifications to this software may be copyrighted by their authors
// and need not follow the licensing terms described here, provided that
// the new terms are clearly indicated on the first page of each file where
// they apply.
// Last File Update: 21-Jul-1997
// 
#ifndef ANIMATION_DATA_H
#define ANIMATION_DATA_H
#include <LINK/basic/general.h>
#include <LINK/basic/DList.h>
#define FORWARD  1
#define BACKWARD 0
class AnimationData;
class AnimationData {
	DList<String> cmds;
	DList<String> undo_cmds;
	ContainerNode *current_cmd;
	ContainerNode *current_undo_cmd;
	int id, _direction;
public:
	AnimationData(int i=0) : id(i), _direction(FORWARD),
			         current_cmd(0), current_undo_cmd(0) {}
        ~AnimationData();
	int identifier()const	{return id;}
	void setIdentifier(int i){id = i;}
	int direction()	const	{return _direction;}
	void setDirection(int d) { _direction = d;}
	void appendCmd(String cmd, String undo_cmd);
	void debug();
	void markCurrent();
	void clearMarks();
	int currentMarkedQ() const;	// mark - user break
	int currentInitQ() const;	// init - an initialization step (not
	String resetCmds();		//	  to be stopped at)
	String resetUndoCmds();
	String currentCmd();
	String currentUndoCmd();
	String prevUndoCmd();
	String nextCmd();
        int operator< (const AnimationData& c) const;
        int operator==(const AnimationData& c) const;
        int operator!=(const AnimationData& c) const;
        friend ostream& operator<<(ostream& os, const AnimationData& c)
                                { os << c.id << endl; return os; }
};
#endif ANIMATION_DATA_H
